#include <core>
#include <console>
#include <string>
#include <admin>
#include <adminlib>
#define ACCESS_DEMOCRACY 8192
new STRING_VERSION[MAX_DATA_LENGTH] = "2.50.50";

/* -=Plugin_Democracy v2.0 Beta=-  http://www.KrezerJ.com - KrezerJ@KrezerJ.com
 *
 *   Modified by JTP10181 (jtp10181@iname.com)
 *   To work with AdminMod 2.50.50 and greater
 *   Version 20030322
 *
 *                ==>   First, Please Read The Manual!   <===
 *  admin_democracy - Displays Vote Status GUI / Menu
 *  admin_democracy <# or CMD> <on/off/vote/disable/enable>
 *
 *  Notes: This Plugin Includes Dynamic Creation of Custom Votes, Auto Vote Timers,
 *         Admin Vote Status GUI, Status Auto Responses with customizable triggers,
 *         and Customizable Vote Ratio's.  Votes can be disabled in game and saved
 *         In Vault.ini between maps.  Vote Spam Protection is also included.
 */

/* Must be updated if you create additional votes */
#define TOTAL_VOTES 10

/* Save Disabled votes between maps using vault.ini */
#define USE_VAULT 1

/* If LogD is installed,  Enable this to force  *
 * players to drop disabled guns at round start */
#define USE_LOGD 1

/* Defines the number of secconds players must wait *
 * To repeat the SAME VOTE.  this stops vote spams! */
#define RV_FREQ 120

/* saying any of these words will display current gun mode  */
new VT_STATUS[6][] = { "pistol", "awp", "knives", "scout", "smg", "nvg" };

/* Custom centersay Color For Fun!! { Red, Green, Blue }*/
new VT_COLOR[3] = { 63, 187, 239 };

new VT_CMD[TOTAL_VOTES][MAX_COMMAND_LENGTH];
new VT_DESC[TOTAL_VOTES][MAX_TEXT_LENGTH];
new VT_MODE[TOTAL_VOTES];  /* 1=Enabled, 0=NotEnabled, -1=JustVotedOn+Failed */
new VT_DROP_PRI[TOTAL_VOTES]; new VT_AUTO[TOTAL_VOTES];
new VT_DROP_SEC[TOTAL_VOTES]; new VT_RATIO[TOTAL_VOTES];
new VT_DROP_RPT[TOTAL_VOTES]; new VT_DSBL[TOTAL_VOTES];
new VT_ACTIVE;
#if USE_LOGD==1
new VT_LOGD_MODE=-1;
#endif

VT_VARS() {
	/*******************************
	** Start Custom Vote Settings **
	*******************************/

	new i=0;	/* 1st Vote - DEFAULT */
	VT_CMD[i]   = "all";          /* Command gets prefixed with vote_  example: vote_all (no spaces)    */
	VT_DESC[i]  = "All Weapons and Equipment";  /* Descriptin, Pistols Only has been Enabled, etc..                   */
	VT_AUTO[i]  = 0;              /* Auto-start this vote so many secconds into map (0=disable)         */
	VT_RATIO[i] = 51;             /* Percentage Ratio of players that must vote to win                  */
	VT_DSBL[i]  = 0;              /* Change to 1 to disabled public use of the vote_all by default      */
	/* These Three Options Requre LogD to function!! */
	VT_DROP_PRI[i] = 0;           /* Tele-Drop Primary Weapon at FIRST Round Start after vote(1=enable) */
	VT_DROP_SEC[i] = 0;           /* Tele-Drop Secondary Weapon at FIRST Round Start after vote         */
	VT_DROP_RPT[i] = 0;           /* Repeat Tele-Drop EVERY ROUND!  Only use this if you have to.       */

	i=1;		/* 2nd Vote */
	VT_CMD[i]   = "pistols";
	VT_DESC[i]  = "Pistols Only";
	VT_AUTO[i]  = 0;
	VT_RATIO[i] = 51;
	VT_DSBL[i]  = 1;
	VT_DROP_PRI[i] = 1;
	VT_DROP_SEC[i] = 0;
	VT_DROP_RPT[i] = 0;

	i=2;		/* 3rd Vote */
	VT_CMD[i]   = "noawp";
	VT_DESC[i]  = "No AWPs/AWMs";
	VT_AUTO[i]  = 0;
	VT_RATIO[i] = 51;
	VT_DSBL[i]  = 1;
	VT_DROP_PRI[i] = 1;
	VT_DROP_SEC[i] = 0;
	VT_DROP_RPT[i] = 0;

	i=3;		/* 4th Vote */
	VT_CMD[i]   = "knives";
	VT_DESC[i]  = "Knives Only";
	VT_AUTO[i]  = 0;
	VT_RATIO[i] = 51;
	VT_DSBL[i]  = 1;
	VT_DROP_PRI[i] = 1;
	VT_DROP_SEC[i] = 1;
	VT_DROP_RPT[i] = 1;

	i=4;		/* 5th Vote */
	VT_CMD[i]   = "pumps";
	VT_DESC[i]  = "Pumps Only";
	VT_AUTO[i]  = 0;
	VT_RATIO[i] = 51;
	VT_DSBL[i]  = 1;
	VT_DROP_PRI[i] = 1;
	VT_DROP_SEC[i] = 1;
	VT_DROP_RPT[i] = 0;

	i=5;		/* 6th Vote */
	VT_CMD[i]   = "scouts";
	VT_DESC[i]  = "Scouts Only";
	VT_AUTO[i]  = 0;
	VT_RATIO[i] = 51;
	VT_DSBL[i]  = 1;
	VT_DROP_PRI[i] = 1;
	VT_DROP_SEC[i] = 1;
	VT_DROP_RPT[i] = 0;

	i=6;		/* 7th Vote */
	VT_CMD[i]   = "smgs";
	VT_DESC[i]  = "SMGs Only";
	VT_AUTO[i]  = 0;
	VT_RATIO[i] = 51;
	VT_DSBL[i]  = 1;
	VT_DROP_PRI[i] = 1;
	VT_DROP_SEC[i] = 1;
	VT_DROP_RPT[i] = 0;

	i=7;		/* 8th Vote */
	VT_CMD[i]   = "mactmp";
	VT_DESC[i]  = "MAC10 vs TMP";
	VT_AUTO[i]  = 0;
	VT_RATIO[i] = 51;
	VT_DSBL[i]  = 1;
	VT_DROP_PRI[i] = 1;
	VT_DROP_SEC[i] = 1;
	VT_DROP_RPT[i] = 0;

	i=8;		/* 9th Vote */
	VT_CMD[i]   = "nades";
	VT_DESC[i]  = "Grenades Only";
	VT_AUTO[i]  = 0;
	VT_RATIO[i] = 51;
	VT_DSBL[i]  = 1;
	VT_DROP_PRI[i] = 1;
	VT_DROP_SEC[i] = 1;
	VT_DROP_RPT[i] = 1;

	i=9;		/* 10th Vote */
	VT_CMD[i]   = "nvg";
	VT_DESC[i]  = "No NVG";
	VT_AUTO[i]  = 0;
	VT_RATIO[i] = 51;
	VT_DSBL[i]  = 1;
	VT_DROP_PRI[i] = 0;
	VT_DROP_SEC[i] = 0;
	VT_DROP_RPT[i] = 0;

	/*****************************
	** End Custom Vote Settings **    Look below for "Custom Vote Actions"
	*****************************/

	VT_MODE[0] = 1;
	for(i=0; i<TOTAL_VOTES; i++){ /* Create Auto-Vote, */
		if (VT_AUTO[i] > 0) { /* Timers Now!!!     */
			new strIndex[MAX_NUMBER_LENGTH];
			numtostr(i,strIndex);
			set_timer("VT_TIMER",VT_AUTO[i],1,strIndex);
		}
	}
}

VT_EXEC(Index) {
	/******************************
	** Start Custom Vote Actions **
	******************************/

	if(Index==0){
		plugin_exec("admin_enableallweapons", "");
	} else

	if(Index==1){
		plugin_exec("admin_enableallweapons", "");
		plugin_exec("admin_restrictmenu", "2");
		plugin_exec("admin_restrictmenu", "3");
		plugin_exec("admin_restrictmenu", "4");
		plugin_exec("admin_restrictmenu", "5");
	} else

	if(Index==2){
		plugin_exec("admin_enableallweapons", "");
		plugin_exec("admin_restrictweapon", "4 6");
	} else

	if(Index==3){
		plugin_exec("admin_restrictmenu", "1");
		plugin_exec("admin_restrictmenu", "2");
		plugin_exec("admin_restrictmenu", "3");
		plugin_exec("admin_restrictmenu", "4");
		plugin_exec("admin_restrictmenu", "5");
	} else

	if(Index==4){
		plugin_exec("admin_restrictallweapons", "");
		plugin_exec("admin_enableequipment", "");
		plugin_exec("admin_enableweapon", "2 1");

	} else

	if(Index==5){
		plugin_exec("admin_restrictallweapons", "");
		plugin_exec("admin_enableequipment", "");
		plugin_exec("admin_enableweapon", "4 5");

	} else

	if(Index==6){
		plugin_exec("admin_restrictallweapons", "");
		plugin_exec("admin_enableequipment", "");
		plugin_exec("admin_enablemenu", "3");

	} else

	if(Index==7) {
		plugin_exec("admin_restrictallweapons", "");
		plugin_exec("admin_enableequipment", "");
		plugin_exec("admin_enableweapon", "3 2");
		plugin_exec("admin_enableweapon", "3 4");

	} else

	if(Index==8) {
		plugin_exec("admin_restrictallweapons", "");
		plugin_exec("admin_restrictmenu", "6");
		plugin_exec("admin_restrictmenu", "7");
		plugin_exec("admin_enablemenu", "8");

	} else

	if(Index==9) {
		plugin_exec("admin_enableallweapons", "");
		plugin_exec("admin_restrictweapon", "8 7");

	} else

	/****************************
	** End Custom Vote Actions **
	****************************/

	{ return; }

#if USE_LOGD==1
	VT_LOGD_MODE=Index;
#endif

	for(new i=0; i<TOTAL_VOTES; i++){
		if (VT_MODE[i]==1) { VT_MODE[i]=0; }
	}
	VT_ACTIVE=Index;
	VT_MODE[Index]=1;
}

#if USE_LOGD==1
new TeleMode;
new X[MAX_PLAYERS];
new Y[MAX_PLAYERS];
new Z[MAX_PLAYERS];
public VT_LOGD_TELE() {
	new i,tempZ;
	new Name[MAX_NAME_LENGTH];
	new maxplayers = maxplayercount();
	for(i=1; i<= maxplayers; i++) {
		if(playerinfo(i,Name,MAX_NAME_LENGTH)==1) {
			if(TeleMode!=1) {
				get_userorigin(Name, X[i], Y[i], Z[i]);
				tempZ = Z[i] - 1500;
			} else {
				tempZ = 10 + Z[i];
			}
			teleport(Name, X[i], Y[i], tempZ);
		}
	}
	TeleMode=!TeleMode;
}

VT_LOGD_DROP(Data) {
	new i;
	new Name[MAX_NAME_LENGTH];
	new maxplayers = maxplayercount();
	for(i=1; i <= maxplayers; i++) {
		if(playerinfo(i,Name,MAX_NAME_LENGTH)==1) {
			execclient(Name,"weapon_knife");
			if(Data==1) { execclient(Name,"slot1"); }
			if(Data==2) { execclient(Name,"slot2"); }
			execclient(Name,"wait");
			execclient(Name,"+attack");
			execclient(Name,"wait");
			execclient(Name,"-attack");
			execclient(Name,"drop");
		}
	}
	if (Data==1) { say("Primary weapon removed due to mode"); }
	if (Data==2) { say("Pistol removed due to mode"); }
}

public VT_LOGD(HLCommand,HLData,HLUserName,UserIndex) {	/*  on round start do stuff ^_^  */
	new Data[MAX_DATA_LENGTH];
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	if(strcmp("Round_Start", Data)!= 0)
		return PLUGIN_HANDLED;
	if(VT_ACTIVE) {
		new Text[MAX_TEXT_LENGTH];
		snprintf(Text, MAX_TEXT_LENGTH, "%s is Currently Enabled", VT_DESC[VT_ACTIVE]);
		typesay(Text,10,VT_COLOR[0],VT_COLOR[1],VT_COLOR[2]);
	}
	if(VT_LOGD_MODE!=-1) {
		new Index=VT_LOGD_MODE;
		if (VT_DROP_PRI[Index] || VT_DROP_SEC[Index]) {
			VT_LOGD_TELE();
			if (VT_DROP_PRI[Index]) { VT_LOGD_DROP(1); }
			if (VT_DROP_SEC[Index]) { VT_LOGD_DROP(2); }
			set_timer("VT_LOGD_TELE",2,1);
		}
		if (VT_DROP_RPT[Index]!=1) { VT_LOGD_MODE=-1; }
	}
	return PLUGIN_HANDLED;
}
#endif

#if USE_VAULT==1
VT_VAULT() {
	new i;
	new strVAR[MAX_NUMBER_LENGTH];
	new VaultData[MAX_TEXT_LENGTH];
	/* Read Vault Data */
	for(i=0; i<TOTAL_VOTES; i++){
		snprintf(strVAR, MAX_TEXT_LENGTH, "vote_%s", VT_CMD[i]);
		if(get_vaultdata(strVAR,VaultData,MAX_TEXT_LENGTH) != 0){
			VT_DSBL[i]=strtonum(VaultData);
		}
	}
	/* Update Vault Data */
	for(i=0; i<TOTAL_VOTES; i++){
		numtostr(VT_DSBL[i],VaultData);
		snprintf(strVAR, MAX_TEXT_LENGTH, "vote_%s", VT_CMD[i]);
		set_vaultdata(strVAR,VaultData);
	}
}
#endif

public VT_TIMER(Timer,Repeat,HLName,HLParam) {
	new strIndex[MAX_NUMBER_LENGTH];
	convert_string(HLParam,strIndex,MAX_NUMBER_LENGTH);
	new Index=strtonum(strIndex);
	if (VT_MODE[Index]==0){
		if (vote_allowed()!=1){
			set_timer("VT_TIMER",30,1,strIndex);
		} else {
			START_VOTE(Index);
		}
	}
}

public VT_ALLOW(Timer,Repeat,HLName,HLParam) {
	new strIndex[MAX_NUMBER_LENGTH];
	convert_string(HLParam,strIndex,MAX_NUMBER_LENGTH);
	new Index=strtonum(strIndex);
	if(VT_MODE[Index]==-1) {
		VT_MODE[Index]=0;
	}
}

public START_VOTE(Index) {
	new Text[MAX_TEXT_LENGTH];
	new strIndex[MAX_NUMBER_LENGTH];
	numtostr(Index,strIndex); VT_MODE[Index]=-1;
	snprintf(Text, MAX_TEXT_LENGTH, "Enable %s?", VT_DESC[Index]);
	vote(Text, "Yes", "No", "HANDLE_VOTE",strIndex);
}

public HANDLE_VOTE(WinningOption,Data,VoteCount,UserCount) {
	new Text[MAX_TEXT_LENGTH];
	new strIndex[MAX_NUMBER_LENGTH];
	convert_string(Data,strIndex,MAX_NUMBER_LENGTH);
	new Index = strtonum(strIndex);
	new Ratio = VT_RATIO[Index];
	if (VoteCount >= Ratio*UserCount/100) {
		if (WinningOption==1) {
#if USE_LOGD==1
			snprintf(Text, MAX_TEXT_LENGTH, "Vote successful. %s will be Enabled Next Round!!!", VT_DESC[Index]);
#else
			snprintf(Text, MAX_TEXT_LENGTH, "Vote successful. %s is Now Enabled!!!", VT_DESC[Index]);
#endif
			VT_EXEC(Index);
		} else {
			snprintf(Text, MAX_TEXT_LENGTH, "Vote over.  %s will NOT be enabled at this time.", VT_DESC[Index]);
			set_timer("VT_ALLOW",RV_FREQ,1,strIndex);
		}
	} else {
		new strNumber[MAX_NUMBER_LENGTH];
		numtostr(Ratio*UserCount/100,strNumber);
		snprintf(Text, MAX_TEXT_LENGTH, "%s vote completed, but not enough votes for change (needed %s)", VT_DESC[Index], strNumber);
		set_timer("VT_ALLOW",RV_FREQ,1,strIndex);
	}
	say(Text);
	centersay(Text,18,VT_COLOR[0],VT_COLOR[1],VT_COLOR[2]);
}

public admin_vote_dmcy(HLCommand,HLData,HLUserName,UserIndex) {
	new i;
	new Data[MAX_DATA_LENGTH];
	convert_string(HLCommand,Data,MAX_DATA_LENGTH);
	new Length = strlen(Data);
	new strVote[MAX_DATA_LENGTH];
	/* we need to strip out 'admin_vote_' (11 characters */
	for(i=11;i<Length+1;i++)
		strVote[i-11] = Data[i];
	strVote[i-11] = NULL_CHAR;
	for(i=0; i<TOTAL_VOTES; i++){
		if (strcasecmp(strVote, VT_CMD[i])==0){
			new Text[MAX_TEXT_LENGTH];
			if (VT_MODE[i]==1){
				snprintf(Text, MAX_TEXT_LENGTH, "%s is Already Enabled.", VT_DESC[i]);
				selfmessage(Text);
				return PLUGIN_HANDLED;
			}
			if (VT_DSBL[i]){
				snprintf(Text, MAX_TEXT_LENGTH, "Admin has disable public use of vote_%s", VT_CMD[i]);
				selfmessage(Text);
				return PLUGIN_HANDLED;
			}
			if (VT_MODE[i]==-1){
				selfmessage("This vote has just been completed, sorry if you didn't like the results.");
				return PLUGIN_HANDLED;
			}
			if (vote_allowed()!=1){
				selfmessage("Vote not allowed at this time.");
				return PLUGIN_HANDLED;
			}
			snprintf(Text, MAX_TEXT_LENGTH, "Starting vote for %s.", VT_DESC[i]);
			selfmessage(Text);
			START_VOTE(i);
			return PLUGIN_HANDLED;
		}
	}
	return PLUGIN_HANDLED;
}

public admin_democracy(HLCommand,HLData,HLUserName,UserIndex) {
	new i;
	new Data[MAX_DATA_LENGTH];
	new Text[MAX_TEXT_LENGTH];
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	strstripquotes(Data);
	if (strlen(Data)>0 && check_auth(ACCESS_DEMOCRACY)) {
		new Index=-1;
		new First[MAX_TEXT_LENGTH];
		new Second[MAX_TEXT_LENGTH];
		strbreak(Data, First, Second, MAX_DATA_LENGTH);
		if (strlen(First)<3) {
			Index=strtonum(First)-1;
			if((Index>=0 && Index<TOTAL_VOTES)==0) { Index=-1; }
		} else {
			for(i=0; i<TOTAL_VOTES; i++){
				snprintf(Text, MAX_TEXT_LENGTH, "vote_%s", VT_CMD[i]);
				if (strcasecmp(First, Text)==0){
					Index=i; break;
				}
			}
		}
		if(Index!=-1) {
			/*  do stuff ^_^  */
			if (strcasecmp(Second, "on")==0){
				if (VT_MODE[Index]==1){
					snprintf(Text, MAX_TEXT_LENGTH, "%s is Already Running.", VT_DESC[Index]);
					selfmessage(Text);
				} else {
					VT_EXEC(Index);
					snprintf(Text, MAX_TEXT_LENGTH, "%s is Now Running.", VT_DESC[Index]);
					selfmessage(Text);
					snprintf(Text, MAX_TEXT_LENGTH, "Admin has enabled %s.", VT_DESC[Index]);
					say(Text);
					centersay(Text,18,VT_COLOR[0],VT_COLOR[1],VT_COLOR[2]);
				}
				return PLUGIN_HANDLED;
			}
			if (strcasecmp(Second, "off")==0){
				if (VT_MODE[Index]!=1){
					snprintf(Text, MAX_TEXT_LENGTH, "%s is Already Turned Off.", VT_DESC[Index]);
					selfmessage(Text);
				} else {
					VT_EXEC(0);
					snprintf(Text, MAX_TEXT_LENGTH, "%s is Now Off. Guns have returned to %s.", VT_DESC[Index], VT_DESC[0]);
					selfmessage(Text);
					snprintf(Text, MAX_TEXT_LENGTH, "Admin has enabled %s.", VT_DESC[0]);
					say(Text);
					centersay(Text,18,VT_COLOR[0],VT_COLOR[1],VT_COLOR[2]);
				}
				return PLUGIN_HANDLED;
			}
			if (strcasecmp(Second, "vote")==0){
				if (VT_MODE[Index]==1){
					snprintf(Text, MAX_TEXT_LENGTH, "%s is Already Running.", VT_DESC[Index]);
					selfmessage(Text);
				} else {
					if (vote_allowed()!=1){
						selfmessage("Vote not allowed at this time");
					} else {
						START_VOTE(Index);
						snprintf(Text, MAX_TEXT_LENGTH, "%s vote started.", VT_DESC[Index]);
						selfmessage(Text);
					}
				}
				return PLUGIN_HANDLED;
			}
			if (strcasecmp(Second, "disable")==0){
				if (VT_DSBL[Index]==1){
					snprintf(Text, MAX_TEXT_LENGTH, "Public use of vote_%s is Already Disabled.", VT_CMD[Index]);
					selfmessage(Text);
				} else {
					VT_DSBL[Index]=1;
#if USE_VAULT==1
					snprintf(Text, MAX_TEXT_LENGTH, "vote_%s", VT_CMD[Index]);
					set_vaultdata(Text,"1");
#endif
					snprintf(Text, MAX_TEXT_LENGTH, "Public use of vote_%s is Now Disabled.", VT_CMD[Index]);
					selfmessage(Text);
					snprintf(Text, MAX_TEXT_LENGTH, "Admin has Disabled use of vote_%s.", VT_CMD[Index]);
					say(Text);
					centersay(Text,18,VT_COLOR[0],VT_COLOR[1],VT_COLOR[2]);
				}
				return PLUGIN_HANDLED;
			}
			if (strcasecmp(Second, "enable")==0){
				if (VT_DSBL[Index]==0){
					snprintf(Text, MAX_TEXT_LENGTH, "Public use of vote_%s is Already Enabled.", VT_CMD[Index]);
					selfmessage(Text);
				} else {
					VT_DSBL[Index]=0;
#if USE_VAULT==1
					snprintf(Text, MAX_TEXT_LENGTH, "vote_%s", VT_CMD[Index]);
					set_vaultdata(Text,"0");
#endif
					snprintf(Text, MAX_TEXT_LENGTH, "Public use of vote_%s is Now Enabled.", VT_CMD[Index]);
					selfmessage(Text);
					snprintf(Text, MAX_TEXT_LENGTH, "Admin has Enabled use of vote_%s.", VT_CMD[Index]);
					say(Text);
					centersay(Text,18,VT_COLOR[0],VT_COLOR[1],VT_COLOR[2]);
				}
				return PLUGIN_HANDLED;
			}
		}
		/* Display error and then print Vote Status GUI */
		selfmessage("ERROR: Invalid Data Entry^n");
	}
	/* Print Vote Status GUI */
	new Mode[MAX_TEXT_LENGTH];
	selfmessage("# Mode     Command - Description");
	for(i=0; i<TOTAL_VOTES; i++){
		if(VT_MODE[i]==0){ Mode="       "; }
		if(VT_MODE[i]==-1){Mode="JustVoted"; }
		if(VT_DSBL[i]==1){ Mode="Disabled "; }
		if(VT_MODE[i]==1){ Mode="Active  "; }
		snprintf(Text, MAX_TEXT_LENGTH, "%i %s vote_%s - %s", i+1, Mode, VT_CMD[i], VT_DESC[i]);
		selfmessage(Text);
	}
	if (check_auth(ACCESS_DEMOCRACY)){
		selfmessage("^nTo Modify Settings, type: admin_democracy <# or CMD> <on/off/vote/disable/enable>");
	}
	return PLUGIN_HANDLED;
}


public HandleSay(HLCommand,HLData,HLUserName,UserIndex) {
	new i;
	new Data[MAX_DATA_LENGTH];
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	strstripquotes(Data);
	if(strmatch(Data,"vote_",strlen("vote_"))==1) {
		new strVote[MAX_DATA_LENGTH];
		new Length = strlen(Data);
		/* we need to strip out 'vote_' (5 characters) */
		for(i=5;i<Length+1;i++)
			strVote[i-5] = Data[i];
		strVote[i-5] = NULL_CHAR;
		for(i=0; i<TOTAL_VOTES; i++){
			if (strcasecmp(strVote, VT_CMD[i])==0){
				new Text[MAX_TEXT_LENGTH];
				if (VT_MODE[i]==1){
					snprintf(Text, MAX_TEXT_LENGTH, "%s is Already Enabled.", VT_DESC[i]);
					say(Text);
					return PLUGIN_CONTINUE;
				}
				if (VT_DSBL[i]){
					snprintf(Text, MAX_TEXT_LENGTH, "Admin has disable public use of vote_%s", VT_CMD[i]);
					say(Text);
					return PLUGIN_CONTINUE;
				}
				if (VT_MODE[i]==-1){
					say("This vote has just been completed, sorry if you didn't like the results.");
					return PLUGIN_CONTINUE;
				}
				if (vote_allowed()!=1){
					say("Vote not allowed at this time.");
					return PLUGIN_CONTINUE;
				}
				snprintf(Text, MAX_TEXT_LENGTH, "Starting vote for %s.", VT_DESC[i]);
				say(Text);
				START_VOTE(i);
				return PLUGIN_CONTINUE;
			}
		}
	}
	/* Print Current Gun Mode if requested! */
	new nstat=sizeof VT_STATUS;
	for(i=0; i<nstat; i++){
		if (strcasestr(Data, VT_STATUS[i])!=-1) {
			new Text[MAX_TEXT_LENGTH];
			snprintf(Text, MAX_TEXT_LENGTH, "%s is Currently Enabled", VT_DESC[VT_ACTIVE]);
			centersay(Text,18,VT_COLOR[0],VT_COLOR[1],VT_COLOR[2]);
			say(Text);
			/* To change type: vote_all, vote_pistols, vote_awp .... */
			new Msg[MAX_TEXT_LENGTH] = "Votes: ";
			for(i=0; i<TOTAL_VOTES; i++){
				if (i!=0){ strcpy(Msg[strlen(Msg)],", ",MAX_TEXT_LENGTH); }
				if (VT_DSBL[i]==0) { snprintf(Text, MAX_TEXT_LENGTH, "vote_%s", VT_CMD[i]); }
				if (strlen(Text)+strlen(Msg)>100) { say(Msg); Msg=""; }
				strcpy(Msg[strlen(Msg)],Text,MAX_TEXT_LENGTH);
			}
			say(Msg);
			//say("Anyone can start a vote for all weapons with vote_all");
			return PLUGIN_CONTINUE;
		}
	}
	if (strcasestr(Data, "democracy")!=-1) {
		centersay ("This Server is using Plugin_Democracy v2.0^nWritten by KrezerJ and Fixed by JTP10181",9,0,255,0);
	}
	return PLUGIN_CONTINUE;
}

public plugin_init() {
	plugin_registerinfo("Democracy Plugin","Dynamic Gun Vote Creation System",STRING_VERSION);
	plugin_registercmd("admin_democracy","admin_democracy",ACCESS_ALL,"admin_democracy : Displays Vote Status GUI.");
	plugin_registerhelp("admin_democracy",ACCESS_DEMOCRACY,"admin_democracy <# or CMD> <on/off/vote/disable/enable> : Modify Votes");
	plugin_registercmd("say","HandleSay",ACCESS_ALL);
	plugin_registercmd("VT_LOGD","VT_LOGD",ACCESS_RCON);
	VT_VARS();

	for(new i=0; i<TOTAL_VOTES; i++){
		new Text[MAX_TEXT_LENGTH];
		new TextB[MAX_TEXT_LENGTH];
		snprintf(Text, MAX_TEXT_LENGTH, "admin_vote_%s", VT_CMD[i]);
		snprintf(TextB, MAX_TEXT_LENGTH, "admin_vote_%s : Starts a vote for %s.", VT_CMD[i], VT_DESC[i]);
		plugin_registercmd(Text,"admin_vote_dmcy",ACCESS_ALL,TextB);
	}

#if USE_VAULT==1
	VT_VAULT();
#endif

#if USE_LOGD==1
	exec( "logd_reg 62 admin_command VT_LOGD" );
#endif

	return PLUGIN_CONTINUE;
}